#########################################################################
#
#      This file was generated using Parse::Yapp version 0.31.
#
#          Don't edit this file, use source file instead.
#
#               ANY CHANGE MADE HERE WILL BE LOST !
#
#########################################################################
package DCParse;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
use Parse::Yapp::Driver;

#line 1 "dc.yp"
# Yapp DC parser grammar
#
# Author: Yunjian William Jiang
# Copyright (c) 2002 The Regents of the Univ. of California. 
# All rights reserved.
#
# Permission is hereby granted, without written agreement and without license
# or royalty fees, to use, copy, modify, and distribute this software and its
# documentation for any purpose, provided that the above copyright notice and
# the following two paragraphs appear in all copies of this software.
#
# IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
# OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
# CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
# "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE
# MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.]
#
# Notes:
# This converter only works on the subset of DC formats generated by Esterel
# compiler:
#  -- no [package|action|instance] table
#  -- no structured types (array|record)
#  -- no [equ|memo] cases, no [procedure|node|action] calls
#  -- no window 
#

require 5.005;
use Parse::CLex;

#intermediate data structure for cfsm
my (%equs, %mems, @proccalls);
my ($pi,$po,$module);
my (@nets, @const, @func, @proc, @types, @nodes);
my ($mylexer);
my @defined_types = ("Boolean", "Integer", "Float", "Double");
my @defined_const = (0, 1);
my @defined_funcs = ("COND", "EQ", "NEQ", "OR", "AND", "NOT", "XOR", 
"IEQ", "INEQ", "ILT", "ILEQ", "IGT", "IGEQ", "IPLUS", "IMINUS", "IMUL", "IMOD", "IDIV", "IUMINUS",
"FEQ", "FNEQ", "FLT", "FLEQ", "FGT", "FGEQ", "FPLUS", "FMINUS", "FMUL", "FDIV", "FUMINUS",
"DEQ", "DNEQ", "DLT", "DLEQ", "DGT", "DGEQ", "DPLUS", "DMINUS", "DMUL", "DDIV", "DUMINUS",
"C1", "C2", "C3");


my $Symbol = '#Yapp-DC-Parser version 0.1 (c) 2002 UC Berkeley';
sub version { $Symbol }
sub module  { $_[0]->{MODULE} }
sub nets   { @{$_[0]->{NETS}} }
sub nodes  { @{$_[0]->{NODES}} }
sub proc   { @{$_[0]->{PROC}} }
sub func   { @{$_[0]->{FUNC}} }
sub const  { @{$_[0]->{CONST}} }
sub pi     { (@{$_[0]->{PI}}) }
sub po     { (@{$_[0]->{PO}}) }
sub get_equ   { ($_[0]->{EQUS}{$_[1]}) }
sub get_mem   { ($_[0]->{MEMS}{$_[1]}) }
sub get_net   { ($_[0]->{NETS}[$_[1]]) }
sub add_net   { push @{$_[0]->{NETS}}, $_[1]; }

my @token = (
	qw(KEYWORD (actcall|actions|array|assert|assume|at|check|constants|definitions|dependences|depends|endpackage|end|equ|extern|flows|functions|inflows|locflows|memo|memorysafe|nodecall|nodes|outflows|package|packages|proccall|procedures|prove|record|safe|types|unsafe|value|window)),

	# very naughty -- reaching into token package to rearrange things
        # replace 'KEYWORD' with the keyword itself
	sub { $_[0]->[2] = $_[0]->[1]; $_[0] }, 

	qw(
		SEMICOLON ;
		COLON     :
		COMMA     ,
		DOLLAR    \$
		NUMB      \#
		AT        \@
		EXPON     \^
		PLUS      \+
		MINUS     -
		LPAREN    [\(]
		RPAREN    [\)]
		LSQPAR    [\[]
		RSQPAR    [\]]
		DOT       \.
		integer   [0-9]+
		string    \".*\"
		pragmadef \%.*\%
		identifier [A-Za-z_][A-Za-z0-9_]*
	),
	qw(ERROR  .*), sub { die qq!can\'t analyze: "$_[1]"!; }
	);


sub initialize {
    my($self,$trace,$data)=@_;

    $$self{EQUS}={};    undef %equs;
    $$self{MEMS}={};    undef %mems;
    $$self{PI}=[];      undef $pi;
    $$self{PO}=[];      undef $po;
    $$self{MODULE}='';  undef $module;
    $$self{NETS}=[];    undef @nets;
    $$self{PROC}=[];    undef @proc;
    $$self{FUNC}=[];    undef @func;
    $$self{CONST}=[];   undef @const;
    $$self{NODES}=[];   undef @nodes;

    Parse::CLex->skip('[\s\t\n]+');
    Parse::CLex->trace if $trace;
    $mylexer = new Parse::CLex(@token);
    $mylexer->from($data);
}
sub activate {
    my($self)=shift;
    $$self{PI}     = $pi;
    $$self{PO}     = $po;
    $$self{MODULE} = $module;
    $$self{NETS}   = [@nets];
    $$self{NODES}  = [@nodes];
    $$self{EQUS}   = {%equs};
    $$self{MEMS}   = {%mems};
    $$self{PROC}   = [@proc];
    $$self{FUNC}   = [@func];
    $$self{CONST}  = [@const];
}

sub Lexer { 
    my $token = $mylexer->next(); 
    #print "ATTENTION:\t";
    #print "buffer=", $mylexer->buffer(), "\t";
    #print "linenum=", $mylexer->line(), "\n";

    if (not $token or $mylexer->eoi) {
        return ('', undef);
    } else {
        #print "ATTENTION: got TOKEN=",$token->name,"  VALUE=",$token->text,"\n";
        return ($token->name, $token->text); 
    }
};

sub Error {print STDERR "error: ", $_[0]->YYNberr();}

###############################################################################


sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '0.31',
                                  yystates =>
[
	{#State 0
		ACTIONS => {
			'package' => 2
		},
		GOTOS => {
			'UNIT' => 1,
			'package_entry' => 3,
			'package_list' => 4
		}
	},
	{#State 1
		ACTIONS => {
			'' => 5
		}
	},
	{#State 2
		ACTIONS => {
			'COLON' => 6
		}
	},
	{#State 3
		DEFAULT => -2
	},
	{#State 4
		ACTIONS => {
			'package' => 2
		},
		DEFAULT => -1,
		GOTOS => {
			'package_entry' => 7
		}
	},
	{#State 5
		DEFAULT => -0
	},
	{#State 6
		ACTIONS => {
			'identifier' => 8
		}
	},
	{#State 7
		DEFAULT => -3
	},
	{#State 8
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 9
		}
	},
	{#State 9
		ACTIONS => {
			'types' => 12
		},
		DEFAULT => -5,
		GOTOS => {
			'type_table' => 11
		}
	},
	{#State 10
		DEFAULT => -137
	},
	{#State 11
		ACTIONS => {
			'constants' => 14
		},
		DEFAULT => -12,
		GOTOS => {
			'constant_table' => 13
		}
	},
	{#State 12
		ACTIONS => {
			'COLON' => 15
		}
	},
	{#State 13
		ACTIONS => {
			'functions' => 16
		},
		DEFAULT => -24,
		GOTOS => {
			'function_table' => 17
		}
	},
	{#State 14
		ACTIONS => {
			'COLON' => 18
		}
	},
	{#State 15
		ACTIONS => {
			'integer' => 19
		}
	},
	{#State 16
		ACTIONS => {
			'COLON' => 20
		}
	},
	{#State 17
		ACTIONS => {
			'procedures' => 22
		},
		DEFAULT => -37,
		GOTOS => {
			'procedure_table' => 21
		}
	},
	{#State 18
		ACTIONS => {
			'integer' => 23
		}
	},
	{#State 19
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 24
		}
	},
	{#State 20
		ACTIONS => {
			'integer' => 25
		}
	},
	{#State 21
		ACTIONS => {
			'nodes' => 26
		},
		DEFAULT => -52,
		GOTOS => {
			'node_table' => 27
		}
	},
	{#State 22
		ACTIONS => {
			'COLON' => 28
		}
	},
	{#State 23
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 29
		}
	},
	{#State 24
		ACTIONS => {
			'integer' => 31
		},
		GOTOS => {
			'type_entry' => 30,
			'type_entry_list' => 32
		}
	},
	{#State 25
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 33
		}
	},
	{#State 26
		ACTIONS => {
			'COLON' => 34
		}
	},
	{#State 27
		ACTIONS => {
			'endpackage' => 35
		}
	},
	{#State 28
		ACTIONS => {
			'integer' => 36
		}
	},
	{#State 29
		ACTIONS => {
			'integer' => 38
		},
		GOTOS => {
			'constant_entry' => 37,
			'constant_entry_list' => 39
		}
	},
	{#State 30
		DEFAULT => -7
	},
	{#State 31
		ACTIONS => {
			'COLON' => 40
		}
	},
	{#State 32
		ACTIONS => {
			'integer' => 31,
			'end' => 42
		},
		GOTOS => {
			'type_entry' => 41
		}
	},
	{#State 33
		ACTIONS => {
			'integer' => 44
		},
		GOTOS => {
			'function_entry_list' => 43,
			'function_entry' => 45
		}
	},
	{#State 34
		ACTIONS => {
			'integer' => 46
		}
	},
	{#State 35
		ACTIONS => {
			'COLON' => 47
		}
	},
	{#State 36
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 48
		}
	},
	{#State 37
		DEFAULT => -14
	},
	{#State 38
		ACTIONS => {
			'COLON' => 49
		}
	},
	{#State 39
		ACTIONS => {
			'integer' => 38,
			'end' => 51
		},
		GOTOS => {
			'constant_entry' => 50
		}
	},
	{#State 40
		ACTIONS => {
			'identifier' => 53,
			'integer' => 54
		},
		GOTOS => {
			'type_def' => 52
		}
	},
	{#State 41
		DEFAULT => -8
	},
	{#State 42
		ACTIONS => {
			'COLON' => 55
		}
	},
	{#State 43
		ACTIONS => {
			'integer' => 44,
			'end' => 57
		},
		GOTOS => {
			'function_entry' => 56
		}
	},
	{#State 44
		ACTIONS => {
			'COLON' => 58
		}
	},
	{#State 45
		DEFAULT => -26
	},
	{#State 46
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 59
		}
	},
	{#State 47
		DEFAULT => -4
	},
	{#State 48
		ACTIONS => {
			'integer' => 62
		},
		GOTOS => {
			'proc_entry_list' => 60,
			'proc_entry' => 61
		}
	},
	{#State 49
		ACTIONS => {
			'identifier' => 64,
			'integer' => 65
		},
		GOTOS => {
			'constant_def' => 63
		}
	},
	{#State 50
		DEFAULT => -15
	},
	{#State 51
		ACTIONS => {
			'COLON' => 66
		}
	},
	{#State 52
		ACTIONS => {
			'SEMICOLON' => 67
		}
	},
	{#State 53
		DEFAULT => -11
	},
	{#State 54
		ACTIONS => {
			'DOT' => 68
		}
	},
	{#State 55
		DEFAULT => -6
	},
	{#State 56
		DEFAULT => -27
	},
	{#State 57
		ACTIONS => {
			'COLON' => 69
		}
	},
	{#State 58
		ACTIONS => {
			'identifier' => 72,
			'integer' => 74
		},
		GOTOS => {
			'external_function' => 70,
			'imported_function' => 71,
			'function_def' => 73
		}
	},
	{#State 59
		ACTIONS => {
			'integer' => 76
		},
		GOTOS => {
			'node_entry_list' => 75,
			'node_entry' => 77
		}
	},
	{#State 60
		ACTIONS => {
			'integer' => 62,
			'end' => 79
		},
		GOTOS => {
			'proc_entry' => 78
		}
	},
	{#State 61
		DEFAULT => -39
	},
	{#State 62
		ACTIONS => {
			'COLON' => 80
		}
	},
	{#State 63
		ACTIONS => {
			'SEMICOLON' => 81
		}
	},
	{#State 64
		ACTIONS => {
			'integer' => 83,
			'DOLLAR' => 82
		},
		GOTOS => {
			'type_ref' => 84
		}
	},
	{#State 65
		ACTIONS => {
			'DOT' => 85
		}
	},
	{#State 66
		DEFAULT => -13
	},
	{#State 67
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 86
		}
	},
	{#State 68
		ACTIONS => {
			'identifier' => 87
		}
	},
	{#State 69
		DEFAULT => -25
	},
	{#State 70
		DEFAULT => -29
	},
	{#State 71
		DEFAULT => -30
	},
	{#State 72
		ACTIONS => {
			'LPAREN' => 88
		}
	},
	{#State 73
		ACTIONS => {
			'SEMICOLON' => 89
		}
	},
	{#State 74
		ACTIONS => {
			'DOT' => 90
		}
	},
	{#State 75
		ACTIONS => {
			'integer' => 76,
			'end' => 92
		},
		GOTOS => {
			'node_entry' => 91
		}
	},
	{#State 76
		ACTIONS => {
			'COLON' => 93
		}
	},
	{#State 77
		DEFAULT => -54
	},
	{#State 78
		DEFAULT => -40
	},
	{#State 79
		ACTIONS => {
			'COLON' => 94
		}
	},
	{#State 80
		ACTIONS => {
			'identifier' => 96,
			'integer' => 97
		},
		GOTOS => {
			'proc_def' => 95,
			'external_proc' => 98,
			'imported_proc' => 99
		}
	},
	{#State 81
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 100
		}
	},
	{#State 82
		ACTIONS => {
			'integer' => 101
		}
	},
	{#State 83
		DEFAULT => -20
	},
	{#State 84
		ACTIONS => {
			'value' => 102
		},
		DEFAULT => -17,
		GOTOS => {
			'constant_value' => 103
		}
	},
	{#State 85
		ACTIONS => {
			'identifier' => 104
		}
	},
	{#State 86
		DEFAULT => -9
	},
	{#State 87
		DEFAULT => -10
	},
	{#State 88
		ACTIONS => {
			'RPAREN' => 105,
			'identifier' => 107,
			'integer' => 83,
			'DOLLAR' => 82
		},
		GOTOS => {
			'parameter' => 106,
			'parameter_list' => 108,
			'type_ref' => 109
		}
	},
	{#State 89
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 110
		}
	},
	{#State 90
		ACTIONS => {
			'identifier' => 111
		}
	},
	{#State 91
		DEFAULT => -55
	},
	{#State 92
		ACTIONS => {
			'COLON' => 112
		}
	},
	{#State 93
		ACTIONS => {
			'identifier' => 114
		},
		GOTOS => {
			'imported_node' => 113,
			'node_def' => 115,
			'node' => 116
		}
	},
	{#State 94
		DEFAULT => -38
	},
	{#State 95
		ACTIONS => {
			'SEMICOLON' => 117
		}
	},
	{#State 96
		ACTIONS => {
			'LPAREN' => 118
		}
	},
	{#State 97
		ACTIONS => {
			'DOT' => 119
		}
	},
	{#State 98
		DEFAULT => -42
	},
	{#State 99
		DEFAULT => -43
	},
	{#State 100
		DEFAULT => -16
	},
	{#State 101
		DEFAULT => -21
	},
	{#State 102
		ACTIONS => {
			'COLON' => 120
		}
	},
	{#State 103
		DEFAULT => -19
	},
	{#State 104
		DEFAULT => -18
	},
	{#State 105
		ACTIONS => {
			'COLON' => 121
		}
	},
	{#State 106
		DEFAULT => -48
	},
	{#State 107
		ACTIONS => {
			'integer' => 83,
			'DOLLAR' => 82
		},
		GOTOS => {
			'type_ref' => 122
		}
	},
	{#State 108
		ACTIONS => {
			'RPAREN' => 123,
			'COMMA' => 124
		}
	},
	{#State 109
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 125
		}
	},
	{#State 110
		DEFAULT => -28
	},
	{#State 111
		DEFAULT => -33
	},
	{#State 112
		DEFAULT => -53
	},
	{#State 113
		DEFAULT => -57
	},
	{#State 114
		ACTIONS => {
			'imported' => 127,
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 126
		}
	},
	{#State 115
		DEFAULT => -56
	},
	{#State 116
		DEFAULT => -58
	},
	{#State 117
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 128
		}
	},
	{#State 118
		ACTIONS => {
			'identifier' => 107,
			'integer' => 83,
			'DOLLAR' => 82
		},
		DEFAULT => -46,
		GOTOS => {
			'parameter' => 106,
			'inout_parameters' => 129,
			'parameter_list' => 130,
			'type_ref' => 109
		}
	},
	{#State 119
		ACTIONS => {
			'identifier' => 131
		}
	},
	{#State 120
		ACTIONS => {
			'NUMB' => 135,
			'AT' => 137,
			'integer' => 141,
			'DOLLAR' => 140
		},
		GOTOS => {
			'expression' => 132,
			'constant_expression' => 139,
			'function_call' => 133,
			'function_ref' => 134,
			'flow_ref' => 136,
			'constant_ref' => 138
		}
	},
	{#State 121
		ACTIONS => {
			'integer' => 83,
			'DOLLAR' => 82
		},
		GOTOS => {
			'type_ref' => 142
		}
	},
	{#State 122
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 143
		}
	},
	{#State 123
		ACTIONS => {
			'COLON' => 144
		}
	},
	{#State 124
		ACTIONS => {
			'identifier' => 107,
			'integer' => 83,
			'DOLLAR' => 82
		},
		GOTOS => {
			'parameter' => 145,
			'type_ref' => 109
		}
	},
	{#State 125
		DEFAULT => -51
	},
	{#State 126
		ACTIONS => {
			'flows' => 146
		}
	},
	{#State 127
		ACTIONS => {
			'COLON' => 147
		}
	},
	{#State 128
		DEFAULT => -41
	},
	{#State 129
		ACTIONS => {
			'RPAREN' => 148
		}
	},
	{#State 130
		ACTIONS => {
			'COMMA' => 124
		},
		DEFAULT => -47
	},
	{#State 131
		DEFAULT => -45
	},
	{#State 132
		DEFAULT => -23
	},
	{#State 133
		DEFAULT => -103
	},
	{#State 134
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 149
		}
	},
	{#State 135
		ACTIONS => {
			'integer' => 153
		},
		GOTOS => {
			'number' => 151,
			'double' => 152,
			'float' => 150
		}
	},
	{#State 136
		DEFAULT => -102
	},
	{#State 137
		ACTIONS => {
			'integer' => 155,
			'DOLLAR' => 154
		}
	},
	{#State 138
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 156
		}
	},
	{#State 139
		DEFAULT => -22
	},
	{#State 140
		ACTIONS => {
			'integer' => 157
		}
	},
	{#State 141
		ACTIONS => {
			'LPAREN' => -109,
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 158
		}
	},
	{#State 142
		ACTIONS => {
			'memorysafe' => 161,
			'unsafe' => 159,
			'safe' => 162
		},
		GOTOS => {
			'process_property' => 160
		}
	},
	{#State 143
		DEFAULT => -50
	},
	{#State 144
		ACTIONS => {
			'integer' => 83,
			'DOLLAR' => 82
		},
		GOTOS => {
			'type_ref' => 163
		}
	},
	{#State 145
		DEFAULT => -49
	},
	{#State 146
		ACTIONS => {
			'COLON' => 164
		}
	},
	{#State 147
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 165
		}
	},
	{#State 148
		ACTIONS => {
			'LPAREN' => 166
		}
	},
	{#State 149
		ACTIONS => {
			'LPAREN' => 167
		}
	},
	{#State 150
		DEFAULT => -126
	},
	{#State 151
		DEFAULT => -106
	},
	{#State 152
		DEFAULT => -127
	},
	{#State 153
		ACTIONS => {
			'DOT' => 168
		},
		DEFAULT => -125
	},
	{#State 154
		ACTIONS => {
			'integer' => 169
		}
	},
	{#State 155
		DEFAULT => -104
	},
	{#State 156
		DEFAULT => -101
	},
	{#State 157
		DEFAULT => -110
	},
	{#State 158
		DEFAULT => -100
	},
	{#State 159
		ACTIONS => {
			'COLON' => 170
		}
	},
	{#State 160
		DEFAULT => -32
	},
	{#State 161
		ACTIONS => {
			'COLON' => 171
		}
	},
	{#State 162
		ACTIONS => {
			'COLON' => 172
		}
	},
	{#State 163
		ACTIONS => {
			'memorysafe' => 161,
			'unsafe' => 159,
			'safe' => 162
		},
		GOTOS => {
			'process_property' => 173
		}
	},
	{#State 164
		ACTIONS => {
			'integer' => 174
		}
	},
	{#State 165
		DEFAULT => -59
	},
	{#State 166
		ACTIONS => {
			'identifier' => 107,
			'integer' => 83,
			'DOLLAR' => 82
		},
		DEFAULT => -46,
		GOTOS => {
			'parameter' => 106,
			'inout_parameters' => 175,
			'parameter_list' => 130,
			'type_ref' => 109
		}
	},
	{#State 167
		ACTIONS => {
			'RPAREN' => 177,
			'NUMB' => 135,
			'AT' => 137,
			'integer' => 141,
			'DOLLAR' => 140
		},
		GOTOS => {
			'expression' => 176,
			'function_call' => 133,
			'function_ref' => 134,
			'in_actual_list' => 178,
			'flow_ref' => 136,
			'constant_ref' => 138
		}
	},
	{#State 168
		ACTIONS => {
			'integer' => 179
		}
	},
	{#State 169
		DEFAULT => -105
	},
	{#State 170
		DEFAULT => -36
	},
	{#State 171
		DEFAULT => -35
	},
	{#State 172
		DEFAULT => -34
	},
	{#State 173
		DEFAULT => -31
	},
	{#State 174
		ACTIONS => {
			'inflows' => 180
		},
		DEFAULT => -61,
		GOTOS => {
			'in_flow_table' => 181
		}
	},
	{#State 175
		ACTIONS => {
			'RPAREN' => 182
		}
	},
	{#State 176
		DEFAULT => -111
	},
	{#State 177
		DEFAULT => -107
	},
	{#State 178
		ACTIONS => {
			'RPAREN' => 183,
			'COMMA' => 184
		}
	},
	{#State 179
		ACTIONS => {
			'D' => 186,
			'E' => 187
		},
		DEFAULT => -128,
		GOTOS => {
			'single_exponent' => 185,
			'double_exponent' => 188
		}
	},
	{#State 180
		ACTIONS => {
			'COLON' => 189
		}
	},
	{#State 181
		ACTIONS => {
			'outflows' => 190
		},
		DEFAULT => -63,
		GOTOS => {
			'out_flow_table' => 191
		}
	},
	{#State 182
		ACTIONS => {
			'memorysafe' => 161,
			'unsafe' => 159,
			'safe' => 162
		},
		GOTOS => {
			'process_property' => 192
		}
	},
	{#State 183
		DEFAULT => -108
	},
	{#State 184
		ACTIONS => {
			'NUMB' => 135,
			'AT' => 137,
			'integer' => 141,
			'DOLLAR' => 140
		},
		GOTOS => {
			'expression' => 193,
			'function_call' => 133,
			'function_ref' => 134,
			'flow_ref' => 136,
			'constant_ref' => 138
		}
	},
	{#State 185
		DEFAULT => -129
	},
	{#State 186
		ACTIONS => {
			'MINUS' => 195,
			'PLUS' => 194
		}
	},
	{#State 187
		ACTIONS => {
			'MINUS' => 197,
			'PLUS' => 196,
			'integer' => 198
		}
	},
	{#State 188
		DEFAULT => -133
	},
	{#State 189
		ACTIONS => {
			'integer' => 199
		},
		GOTOS => {
			'flow_table' => 200
		}
	},
	{#State 190
		ACTIONS => {
			'COLON' => 201
		}
	},
	{#State 191
		ACTIONS => {
			'assert' => 203
		},
		DEFAULT => -65,
		GOTOS => {
			'assert_flow_table' => 202
		}
	},
	{#State 192
		DEFAULT => -44
	},
	{#State 193
		DEFAULT => -112
	},
	{#State 194
		ACTIONS => {
			'integer' => 204
		}
	},
	{#State 195
		ACTIONS => {
			'integer' => 205
		}
	},
	{#State 196
		ACTIONS => {
			'integer' => 206
		}
	},
	{#State 197
		ACTIONS => {
			'integer' => 207
		}
	},
	{#State 198
		DEFAULT => -130
	},
	{#State 199
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 208
		}
	},
	{#State 200
		DEFAULT => -62
	},
	{#State 201
		ACTIONS => {
			'integer' => 199
		},
		GOTOS => {
			'flow_table' => 209
		}
	},
	{#State 202
		ACTIONS => {
			'locflows' => 210
		},
		DEFAULT => -67,
		GOTOS => {
			'local_flow_table' => 211
		}
	},
	{#State 203
		ACTIONS => {
			'COLON' => 212
		}
	},
	{#State 204
		DEFAULT => -134
	},
	{#State 205
		DEFAULT => -135
	},
	{#State 206
		DEFAULT => -131
	},
	{#State 207
		DEFAULT => -132
	},
	{#State 208
		ACTIONS => {
			'integer' => 215
		},
		GOTOS => {
			'flow_entry' => 214,
			'flow_entry_list' => 213
		}
	},
	{#State 209
		DEFAULT => -64
	},
	{#State 210
		ACTIONS => {
			'COLON' => 216
		}
	},
	{#State 211
		ACTIONS => {
			'definitions' => 219,
			'extern' => 218
		},
		DEFAULT => -84,
		GOTOS => {
			'definition_table' => 217
		}
	},
	{#State 212
		ACTIONS => {
			'integer' => 199
		},
		GOTOS => {
			'flow_table' => 220
		}
	},
	{#State 213
		ACTIONS => {
			'integer' => 215,
			'end' => 221
		},
		GOTOS => {
			'flow_entry' => 222
		}
	},
	{#State 214
		DEFAULT => -70
	},
	{#State 215
		ACTIONS => {
			'COLON' => 223
		}
	},
	{#State 216
		ACTIONS => {
			'integer' => 199
		},
		GOTOS => {
			'flow_table' => 224
		}
	},
	{#State 217
		ACTIONS => {
			'assertions' => 226
		},
		DEFAULT => -87,
		GOTOS => {
			'assert_def_table' => 225
		}
	},
	{#State 218
		ACTIONS => {
			'COLON' => 227
		}
	},
	{#State 219
		ACTIONS => {
			'COLON' => 228
		}
	},
	{#State 220
		DEFAULT => -66
	},
	{#State 221
		ACTIONS => {
			'COLON' => 229
		}
	},
	{#State 222
		DEFAULT => -71
	},
	{#State 223
		ACTIONS => {
			'identifier' => 230,
			'integer' => 83,
			'DOLLAR' => 82
		},
		GOTOS => {
			'type_ref' => 232,
			'flow_def' => 231
		}
	},
	{#State 224
		DEFAULT => -68
	},
	{#State 225
		ACTIONS => {
			'dependences' => 234
		},
		DEFAULT => -117,
		GOTOS => {
			'dependence_table' => 233
		}
	},
	{#State 226
		ACTIONS => {
			'COLON' => 235
		}
	},
	{#State 227
		DEFAULT => -86
	},
	{#State 228
		ACTIONS => {
			'integer' => 236
		}
	},
	{#State 229
		DEFAULT => -69
	},
	{#State 230
		ACTIONS => {
			'integer' => 83,
			'DOLLAR' => 82
		},
		GOTOS => {
			'type_ref' => 237
		}
	},
	{#State 231
		ACTIONS => {
			'SEMICOLON' => 238
		}
	},
	{#State 232
		ACTIONS => {
			'value' => 240
		},
		DEFAULT => -75,
		GOTOS => {
			'default_value' => 239
		}
	},
	{#State 233
		DEFAULT => -60
	},
	{#State 234
		ACTIONS => {
			'COLON' => 241
		}
	},
	{#State 235
		ACTIONS => {
			'integer' => 242
		}
	},
	{#State 236
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 243
		}
	},
	{#State 237
		ACTIONS => {
			'value' => 240
		},
		DEFAULT => -75,
		GOTOS => {
			'default_value' => 244
		}
	},
	{#State 238
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 245
		}
	},
	{#State 239
		ACTIONS => {
			'prove' => 248,
			'known' => 249,
			'assume' => 251,
			'check' => 250
		},
		DEFAULT => -77,
		GOTOS => {
			'assert_attribute_list' => 246,
			'assert_attribute' => 247
		}
	},
	{#State 240
		ACTIONS => {
			'COLON' => 252
		}
	},
	{#State 241
		ACTIONS => {
			'integer' => 253
		}
	},
	{#State 242
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 254
		}
	},
	{#State 243
		ACTIONS => {
			'integer' => 257
		},
		GOTOS => {
			'definition_entry' => 256,
			'definition_entry_list' => 255
		}
	},
	{#State 244
		ACTIONS => {
			'prove' => 248,
			'known' => 249,
			'assume' => 251,
			'check' => 250
		},
		DEFAULT => -77,
		GOTOS => {
			'assert_attribute_list' => 258,
			'assert_attribute' => 247
		}
	},
	{#State 245
		DEFAULT => -72
	},
	{#State 246
		ACTIONS => {
			'COMMA' => 259
		},
		DEFAULT => -74
	},
	{#State 247
		DEFAULT => -78
	},
	{#State 248
		ACTIONS => {
			'COLON' => 260
		}
	},
	{#State 249
		ACTIONS => {
			'COLON' => 261
		}
	},
	{#State 250
		ACTIONS => {
			'COLON' => 262
		}
	},
	{#State 251
		ACTIONS => {
			'COLON' => 263
		}
	},
	{#State 252
		ACTIONS => {
			'NUMB' => 135,
			'AT' => 137,
			'integer' => 141,
			'DOLLAR' => 140
		},
		GOTOS => {
			'expression' => 132,
			'constant_expression' => 264,
			'function_call' => 133,
			'function_ref' => 134,
			'flow_ref' => 136,
			'constant_ref' => 138
		}
	},
	{#State 253
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 265
		}
	},
	{#State 254
		ACTIONS => {
			'integer' => 257
		},
		GOTOS => {
			'definition_entry' => 256,
			'definition_entry_list' => 266
		}
	},
	{#State 255
		ACTIONS => {
			'integer' => 257,
			'end' => 267
		},
		GOTOS => {
			'definition_entry' => 268
		}
	},
	{#State 256
		DEFAULT => -89
	},
	{#State 257
		ACTIONS => {
			'COLON' => 269
		}
	},
	{#State 258
		ACTIONS => {
			'COMMA' => 259
		},
		DEFAULT => -73
	},
	{#State 259
		ACTIONS => {
			'prove' => 248,
			'known' => 249,
			'assume' => 251,
			'check' => 250
		},
		GOTOS => {
			'assert_attribute' => 270
		}
	},
	{#State 260
		DEFAULT => -83
	},
	{#State 261
		DEFAULT => -81
	},
	{#State 262
		DEFAULT => -82
	},
	{#State 263
		DEFAULT => -80
	},
	{#State 264
		DEFAULT => -76
	},
	{#State 265
		ACTIONS => {
			'integer' => 273
		},
		GOTOS => {
			'dependence_entry' => 272,
			'dependence_entry_list' => 271
		}
	},
	{#State 266
		ACTIONS => {
			'integer' => 257,
			'end' => 274
		},
		GOTOS => {
			'definition_entry' => 268
		}
	},
	{#State 267
		ACTIONS => {
			'COLON' => 275
		}
	},
	{#State 268
		DEFAULT => -90
	},
	{#State 269
		ACTIONS => {
			'proccall' => 276,
			'equ' => 280,
			'memo' => 281
		},
		GOTOS => {
			'definition' => 279,
			'procedure_call' => 277,
			'memorization' => 282,
			'equation' => 278
		}
	},
	{#State 270
		DEFAULT => -79
	},
	{#State 271
		ACTIONS => {
			'integer' => 273,
			'end' => 283
		},
		GOTOS => {
			'dependence_entry' => 284
		}
	},
	{#State 272
		DEFAULT => -119
	},
	{#State 273
		ACTIONS => {
			'COLON' => 285
		}
	},
	{#State 274
		ACTIONS => {
			'COLON' => 286
		}
	},
	{#State 275
		DEFAULT => -85
	},
	{#State 276
		ACTIONS => {
			'COLON' => 287
		}
	},
	{#State 277
		DEFAULT => -94
	},
	{#State 278
		DEFAULT => -92
	},
	{#State 279
		ACTIONS => {
			'SEMICOLON' => 288
		}
	},
	{#State 280
		ACTIONS => {
			'COLON' => 289
		}
	},
	{#State 281
		ACTIONS => {
			'COLON' => 290
		}
	},
	{#State 282
		DEFAULT => -93
	},
	{#State 283
		ACTIONS => {
			'COLON' => 291
		}
	},
	{#State 284
		DEFAULT => -120
	},
	{#State 285
		ACTIONS => {
			'integer' => 296
		},
		GOTOS => {
			'dependence_def' => 294,
			'left_part' => 292,
			'left_part_list' => 295,
			'flow_ref' => 293
		}
	},
	{#State 286
		DEFAULT => -88
	},
	{#State 287
		ACTIONS => {
			'integer' => 297
		}
	},
	{#State 288
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 298
		}
	},
	{#State 289
		ACTIONS => {
			'integer' => 296
		},
		GOTOS => {
			'left_part' => 299,
			'flow_ref' => 293
		}
	},
	{#State 290
		ACTIONS => {
			'integer' => 296
		},
		GOTOS => {
			'left_part' => 300,
			'flow_ref' => 293
		}
	},
	{#State 291
		DEFAULT => -118
	},
	{#State 292
		ACTIONS => {
			'COMMA' => 301
		},
		DEFAULT => -123
	},
	{#State 293
		DEFAULT => -99
	},
	{#State 294
		ACTIONS => {
			'SEMICOLON' => 302
		}
	},
	{#State 295
		ACTIONS => {
			'depends' => 303
		}
	},
	{#State 296
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 158
		}
	},
	{#State 297
		ACTIONS => {
			'LPAREN' => 304
		}
	},
	{#State 298
		DEFAULT => -91
	},
	{#State 299
		ACTIONS => {
			'NUMB' => 135,
			'AT' => 137,
			'integer' => 141,
			'DOLLAR' => 140
		},
		GOTOS => {
			'expression' => 305,
			'function_call' => 133,
			'function_ref' => 134,
			'flow_ref' => 136,
			'constant_ref' => 138
		}
	},
	{#State 300
		ACTIONS => {
			'NUMB' => 135,
			'AT' => 137,
			'integer' => 141,
			'DOLLAR' => 140
		},
		GOTOS => {
			'expression' => 306,
			'function_call' => 133,
			'function_ref' => 134,
			'flow_ref' => 136,
			'constant_ref' => 138
		}
	},
	{#State 301
		ACTIONS => {
			'integer' => 296
		},
		GOTOS => {
			'left_part' => 292,
			'left_part_list' => 307,
			'flow_ref' => 293
		}
	},
	{#State 302
		ACTIONS => {
			'pragmadef' => 10
		},
		DEFAULT => -136,
		GOTOS => {
			'pragma' => 308
		}
	},
	{#State 303
		ACTIONS => {
			'COLON' => 309
		}
	},
	{#State 304
		ACTIONS => {
			'RPAREN' => 310,
			'NUMB' => 135,
			'AT' => 137,
			'integer' => 141,
			'DOLLAR' => 140
		},
		GOTOS => {
			'expression' => 176,
			'function_call' => 133,
			'function_ref' => 134,
			'in_actual_list' => 311,
			'flow_ref' => 136,
			'constant_ref' => 138
		}
	},
	{#State 305
		ACTIONS => {
			'at' => 312
		},
		GOTOS => {
			'activation_condition' => 313
		}
	},
	{#State 306
		ACTIONS => {
			'at' => 312
		},
		GOTOS => {
			'activation_condition' => 314
		}
	},
	{#State 307
		DEFAULT => -124
	},
	{#State 308
		DEFAULT => -121
	},
	{#State 309
		ACTIONS => {
			'integer' => 296
		},
		GOTOS => {
			'left_part' => 292,
			'left_part_list' => 315,
			'flow_ref' => 293
		}
	},
	{#State 310
		ACTIONS => {
			'LPAREN' => 316
		}
	},
	{#State 311
		ACTIONS => {
			'RPAREN' => 317,
			'COMMA' => 184
		}
	},
	{#State 312
		ACTIONS => {
			'COLON' => 318
		}
	},
	{#State 313
		DEFAULT => -97
	},
	{#State 314
		DEFAULT => -98
	},
	{#State 315
		ACTIONS => {
			'at' => 312
		},
		GOTOS => {
			'activation_condition' => 319
		}
	},
	{#State 316
		ACTIONS => {
			'integer' => 296
		},
		GOTOS => {
			'out_actual_list' => 321,
			'flow_ref' => 320
		}
	},
	{#State 317
		ACTIONS => {
			'LPAREN' => 322
		}
	},
	{#State 318
		ACTIONS => {
			'AT' => 324,
			'integer' => 296
		},
		GOTOS => {
			'flow_ref' => 323
		}
	},
	{#State 319
		DEFAULT => -122
	},
	{#State 320
		DEFAULT => -115
	},
	{#State 321
		ACTIONS => {
			'RPAREN' => 325,
			'SEMICOLON' => 326
		}
	},
	{#State 322
		ACTIONS => {
			'integer' => 296
		},
		GOTOS => {
			'out_actual_list' => 327,
			'flow_ref' => 320
		}
	},
	{#State 323
		DEFAULT => -95
	},
	{#State 324
		ACTIONS => {
			'DOLLAR' => 328
		}
	},
	{#State 325
		ACTIONS => {
			'at' => 312
		},
		GOTOS => {
			'activation_condition' => 329
		}
	},
	{#State 326
		ACTIONS => {
			'integer' => 296
		},
		GOTOS => {
			'flow_ref' => 330
		}
	},
	{#State 327
		ACTIONS => {
			'RPAREN' => 331,
			'SEMICOLON' => 326
		}
	},
	{#State 328
		ACTIONS => {
			'integer' => 332
		}
	},
	{#State 329
		DEFAULT => -114
	},
	{#State 330
		DEFAULT => -116
	},
	{#State 331
		ACTIONS => {
			'at' => 312
		},
		GOTOS => {
			'activation_condition' => 333
		}
	},
	{#State 332
		DEFAULT => -96
	},
	{#State 333
		DEFAULT => -113
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 'UNIT', 1, undef
	],
	[#Rule 2
		 'package_list', 1, undef
	],
	[#Rule 3
		 'package_list', 2, undef
	],
	[#Rule 4
		 'package_entry', 11,
sub
#line 171 "dc.yp"
{ $module = $_[3]; }
	],
	[#Rule 5
		 'type_table', 0, undef
	],
	[#Rule 6
		 'type_table', 7, undef
	],
	[#Rule 7
		 'type_entry_list', 1, undef
	],
	[#Rule 8
		 'type_entry_list', 2, undef
	],
	[#Rule 9
		 'type_entry', 5,
sub
#line 190 "dc.yp"
{ push @types, $_[3]; }
	],
	[#Rule 10
		 'type_def', 3,
sub
#line 195 "dc.yp"
{ return $_[1].$_[2].$_[3]; }
	],
	[#Rule 11
		 'type_def', 1,
sub
#line 197 "dc.yp"
{ return $_[1]; }
	],
	[#Rule 12
		 'constant_table', 0, undef
	],
	[#Rule 13
		 'constant_table', 7, undef
	],
	[#Rule 14
		 'constant_entry_list', 1, undef
	],
	[#Rule 15
		 'constant_entry_list', 2, undef
	],
	[#Rule 16
		 'constant_entry', 5,
sub
#line 216 "dc.yp"
{ push @const, $_[3]; }
	],
	[#Rule 17
		 'constant_def', 2,
sub
#line 221 "dc.yp"
{ return {NAME=>$_[1], TYPE=>$_[2], EXT=>"1",} }
	],
	[#Rule 18
		 'constant_def', 3,
sub
#line 223 "dc.yp"
{ return {NAME=>$_[1].$_[2].$_[3], EXT=>"1",} }
	],
	[#Rule 19
		 'constant_def', 3,
sub
#line 225 "dc.yp"
{ return {NAME=>$_[1], TYPE=>$_[2], VALUE=>$_[3],} }
	],
	[#Rule 20
		 'type_ref', 1,
sub
#line 230 "dc.yp"
{ return $types[$_[1]]; }
	],
	[#Rule 21
		 'type_ref', 2,
sub
#line 232 "dc.yp"
{ return $defined_types[$_[2]]; }
	],
	[#Rule 22
		 'constant_value', 3,
sub
#line 237 "dc.yp"
{ $_[3] }
	],
	[#Rule 23
		 'constant_expression', 1,
sub
#line 242 "dc.yp"
{ $_[1] }
	],
	[#Rule 24
		 'function_table', 0, undef
	],
	[#Rule 25
		 'function_table', 7, undef
	],
	[#Rule 26
		 'function_entry_list', 1, undef
	],
	[#Rule 27
		 'function_entry_list', 2, undef
	],
	[#Rule 28
		 'function_entry', 5,
sub
#line 263 "dc.yp"
{ push @func, $_[3]; }
	],
	[#Rule 29
		 'function_def', 1,
sub
#line 268 "dc.yp"
{ $_[1] }
	],
	[#Rule 30
		 'function_def', 1,
sub
#line 270 "dc.yp"
{ $_[1] }
	],
	[#Rule 31
		 'external_function', 7,
sub
#line 276 "dc.yp"
{ return {NAME=>$_[1], PARAM=>$_[3], TYPE=>$_[6], PROP=>$_[7],} }
	],
	[#Rule 32
		 'external_function', 6,
sub
#line 279 "dc.yp"
{ return {NAME=>$_[1], TYPE=>$_[5], PROP=>$_[6],} }
	],
	[#Rule 33
		 'imported_function', 3,
sub
#line 284 "dc.yp"
{ return {NAME=>$_[1].$_[2].$_[3],} }
	],
	[#Rule 34
		 'process_property', 2,
sub
#line 289 "dc.yp"
{ "safe" }
	],
	[#Rule 35
		 'process_property', 2,
sub
#line 291 "dc.yp"
{ "memorysafe" }
	],
	[#Rule 36
		 'process_property', 2,
sub
#line 293 "dc.yp"
{ "unsafe" }
	],
	[#Rule 37
		 'procedure_table', 0, undef
	],
	[#Rule 38
		 'procedure_table', 7, undef
	],
	[#Rule 39
		 'proc_entry_list', 1, undef
	],
	[#Rule 40
		 'proc_entry_list', 2, undef
	],
	[#Rule 41
		 'proc_entry', 5,
sub
#line 312 "dc.yp"
{ push @proc, $_[3]; }
	],
	[#Rule 42
		 'proc_def', 1,
sub
#line 317 "dc.yp"
{ $_[1] }
	],
	[#Rule 43
		 'proc_def', 1,
sub
#line 319 "dc.yp"
{ $_[1] }
	],
	[#Rule 44
		 'external_proc', 8,
sub
#line 325 "dc.yp"
{ return {NAME=>$_[1], PARAMIN=>$_[3], PARAMOUT=>$_[6], PROP=>$_[7],} }
	],
	[#Rule 45
		 'imported_proc', 3,
sub
#line 330 "dc.yp"
{ return {NAME=>$_[1].$_[2].$_[3],} }
	],
	[#Rule 46
		 'inout_parameters', 0, undef
	],
	[#Rule 47
		 'inout_parameters', 1,
sub
#line 336 "dc.yp"
{ $_[1] }
	],
	[#Rule 48
		 'parameter_list', 1,
sub
#line 341 "dc.yp"
{ return [$_[1]]; }
	],
	[#Rule 49
		 'parameter_list', 3,
sub
#line 343 "dc.yp"
{ push (@{$_[1]}, $_[3]); $_[1] }
	],
	[#Rule 50
		 'parameter', 3,
sub
#line 348 "dc.yp"
{ return {NAME=>$_[1], TYPE=>$_[2],} }
	],
	[#Rule 51
		 'parameter', 2,
sub
#line 350 "dc.yp"
{ return {TYPE=>$_[1],} }
	],
	[#Rule 52
		 'node_table', 0, undef
	],
	[#Rule 53
		 'node_table', 7, undef
	],
	[#Rule 54
		 'node_entry_list', 1, undef
	],
	[#Rule 55
		 'node_entry_list', 2, undef
	],
	[#Rule 56
		 'node_entry', 3,
sub
#line 373 "dc.yp"
{ push @nodes, $_[3]; }
	],
	[#Rule 57
		 'node_def', 1,
sub
#line 378 "dc.yp"
{ $_[1] }
	],
	[#Rule 58
		 'node_def', 1,
sub
#line 380 "dc.yp"
{ $_[1] }
	],
	[#Rule 59
		 'imported_node', 4,
sub
#line 385 "dc.yp"
{ $_[1] }
	],
	[#Rule 60
		 'node', 12,
sub
#line 397 "dc.yp"
{ return $_[1]; }
	],
	[#Rule 61
		 'in_flow_table', 0, undef
	],
	[#Rule 62
		 'in_flow_table', 3,
sub
#line 403 "dc.yp"
{ $pi = $_[3]; @nets = (@nets, @{$_[3]}); }
	],
	[#Rule 63
		 'out_flow_table', 0, undef
	],
	[#Rule 64
		 'out_flow_table', 3,
sub
#line 409 "dc.yp"
{ $po = $_[3]; @nets = (@nets, @{$_[3]}); }
	],
	[#Rule 65
		 'assert_flow_table', 0, undef
	],
	[#Rule 66
		 'assert_flow_table', 3, undef
	],
	[#Rule 67
		 'local_flow_table', 0, undef
	],
	[#Rule 68
		 'local_flow_table', 3,
sub
#line 420 "dc.yp"
{ @nets = (@nets, @{$_[3]}); }
	],
	[#Rule 69
		 'flow_table', 5,
sub
#line 428 "dc.yp"
{ $_[3] }
	],
	[#Rule 70
		 'flow_entry_list', 1,
sub
#line 433 "dc.yp"
{ return [$_[1]]; }
	],
	[#Rule 71
		 'flow_entry_list', 2,
sub
#line 435 "dc.yp"
{ push (@{$_[1]}, $_[2]); $_[1] }
	],
	[#Rule 72
		 'flow_entry', 5,
sub
#line 440 "dc.yp"
{ $_[3] }
	],
	[#Rule 73
		 'flow_def', 4,
sub
#line 445 "dc.yp"
{ return {NAME=>$_[1], TYPE=>$_[2], DEFAULT=>$_[3], ASSERT=>$_[4],} }
	],
	[#Rule 74
		 'flow_def', 3,
sub
#line 447 "dc.yp"
{ return {NAME=>"NONE", TYPE=>$_[1], DEFAULT=>$_[2], ASSERT=>$_[3],} }
	],
	[#Rule 75
		 'default_value', 0,
sub
#line 452 "dc.yp"
{ }
	],
	[#Rule 76
		 'default_value', 3,
sub
#line 454 "dc.yp"
{ $_[3] }
	],
	[#Rule 77
		 'assert_attribute_list', 0, undef
	],
	[#Rule 78
		 'assert_attribute_list', 1, undef
	],
	[#Rule 79
		 'assert_attribute_list', 3, undef
	],
	[#Rule 80
		 'assert_attribute', 2, undef
	],
	[#Rule 81
		 'assert_attribute', 2, undef
	],
	[#Rule 82
		 'assert_attribute', 2, undef
	],
	[#Rule 83
		 'assert_attribute', 2, undef
	],
	[#Rule 84
		 'definition_table', 0, undef
	],
	[#Rule 85
		 'definition_table', 7, undef
	],
	[#Rule 86
		 'definition_table', 2, undef
	],
	[#Rule 87
		 'assert_def_table', 0, undef
	],
	[#Rule 88
		 'assert_def_table', 7, undef
	],
	[#Rule 89
		 'definition_entry_list', 1, undef
	],
	[#Rule 90
		 'definition_entry_list', 2, undef
	],
	[#Rule 91
		 'definition_entry', 5, undef
	],
	[#Rule 92
		 'definition', 1, undef
	],
	[#Rule 93
		 'definition', 1, undef
	],
	[#Rule 94
		 'definition', 1, undef
	],
	[#Rule 95
		 'activation_condition', 3,
sub
#line 506 "dc.yp"
{ $_[3] }
	],
	[#Rule 96
		 'activation_condition', 5,
sub
#line 508 "dc.yp"
{ if ($_[5] eq 1) { return 1; } else { return 0; } }
	],
	[#Rule 97
		 'equation', 5,
sub
#line 513 "dc.yp"
{ $equs{$_[3]} = {EXPR=>$_[4], COND=>$_[5],}; }
	],
	[#Rule 98
		 'memorization', 5,
sub
#line 518 "dc.yp"
{ $mems{$_[3]} = {EXPR=>$_[4], COND=>$_[5],}; }
	],
	[#Rule 99
		 'left_part', 1,
sub
#line 523 "dc.yp"
{ $_[1] }
	],
	[#Rule 100
		 'flow_ref', 2,
sub
#line 529 "dc.yp"
{ $_[1] }
	],
	[#Rule 101
		 'expression', 2,
sub
#line 536 "dc.yp"
{ return {TYPE=>"CONST", CONST=>$_[1],} }
	],
	[#Rule 102
		 'expression', 1,
sub
#line 538 "dc.yp"
{ return {TYPE=>"FLOW", FLOW=>$_[1],} }
	],
	[#Rule 103
		 'expression', 1,
sub
#line 540 "dc.yp"
{ return {TYPE=>"FUNC", FUNC=>$_[1],} }
	],
	[#Rule 104
		 'constant_ref', 2,
sub
#line 546 "dc.yp"
{ $const[$_[2]] }
	],
	[#Rule 105
		 'constant_ref', 3,
sub
#line 548 "dc.yp"
{ $defined_const[$_[2]] }
	],
	[#Rule 106
		 'constant_ref', 2,
sub
#line 550 "dc.yp"
{ $_[2] }
	],
	[#Rule 107
		 'function_call', 4,
sub
#line 555 "dc.yp"
{ return {NAME=>$_[1],} }
	],
	[#Rule 108
		 'function_call', 5,
sub
#line 557 "dc.yp"
{ return {NAME=>$_[1], LIST=>$_[4],} }
	],
	[#Rule 109
		 'function_ref', 1,
sub
#line 562 "dc.yp"
{ $func[$_[1]] }
	],
	[#Rule 110
		 'function_ref', 2,
sub
#line 564 "dc.yp"
{ $defined_funcs[$_[2]] }
	],
	[#Rule 111
		 'in_actual_list', 1,
sub
#line 569 "dc.yp"
{ return [$_[1]]; }
	],
	[#Rule 112
		 'in_actual_list', 3,
sub
#line 571 "dc.yp"
{ push (@{$_[1]}, $_[3]); $_[1] }
	],
	[#Rule 113
		 'procedure_call', 10,
sub
#line 577 "dc.yp"
{ push @proccalls, {NAME=>$proc[$_[3]], PARAMIN=>$_[5], PARAMOUT=>$_[8], COND=>$_[10]}; }
	],
	[#Rule 114
		 'procedure_call', 9,
sub
#line 580 "dc.yp"
{ push @proccalls, {NAME=>$proc[$_[3]], PARAMOUT=>$_[7], COND=>$_[9]}; }
	],
	[#Rule 115
		 'out_actual_list', 1,
sub
#line 585 "dc.yp"
{ return [$_[1]] }
	],
	[#Rule 116
		 'out_actual_list', 3,
sub
#line 587 "dc.yp"
{ push (@{$_[1]}, $_[3]); $_[1] }
	],
	[#Rule 117
		 'dependence_table', 0, undef
	],
	[#Rule 118
		 'dependence_table', 7, undef
	],
	[#Rule 119
		 'dependence_entry_list', 1, undef
	],
	[#Rule 120
		 'dependence_entry_list', 2, undef
	],
	[#Rule 121
		 'dependence_entry', 5, undef
	],
	[#Rule 122
		 'dependence_def', 5, undef
	],
	[#Rule 123
		 'left_part_list', 1, undef
	],
	[#Rule 124
		 'left_part_list', 3, undef
	],
	[#Rule 125
		 'number', 1,
sub
#line 621 "dc.yp"
{ $_[1] }
	],
	[#Rule 126
		 'number', 1,
sub
#line 623 "dc.yp"
{ $_[1] }
	],
	[#Rule 127
		 'number', 1,
sub
#line 625 "dc.yp"
{ $_[1] }
	],
	[#Rule 128
		 'float', 3,
sub
#line 630 "dc.yp"
{ ($_[1] + $_[3]*exp(length($_[3])*log(0.1)) ) }
	],
	[#Rule 129
		 'float', 4,
sub
#line 632 "dc.yp"
{ ($_[1] + $_[3]*exp(length($_[3])*log(0.1)) ) * $_[4] }
	],
	[#Rule 130
		 'single_exponent', 2,
sub
#line 637 "dc.yp"
{ $_[2] }
	],
	[#Rule 131
		 'single_exponent', 3,
sub
#line 639 "dc.yp"
{ $_[3] }
	],
	[#Rule 132
		 'single_exponent', 3,
sub
#line 641 "dc.yp"
{ (0-$_[3]) }
	],
	[#Rule 133
		 'double', 4,
sub
#line 646 "dc.yp"
{ ($_[1] + $_[3]*exp(length($_[3])*log(0.1)) ) * $_[4] }
	],
	[#Rule 134
		 'double_exponent', 3,
sub
#line 651 "dc.yp"
{ $_[3] }
	],
	[#Rule 135
		 'double_exponent', 3,
sub
#line 653 "dc.yp"
{ (0-$_[3]) }
	],
	[#Rule 136
		 'pragma', 0, undef
	],
	[#Rule 137
		 'pragma', 1, undef
	]
],
                                  @_);
    bless($self,$class);
}

#line 664 "dc.yp"
 

1;
